﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Threading;
using System.Collections.ObjectModel;
using Service.BoardService;
using System.Windows.Threading;
using Service;
using System.Threading.Tasks;
using Common.Logger;

namespace AnzeigenApp
{
    /// <summary>
    /// Interaktionslogik für AlleAnzeigenView.xaml
    /// </summary>
    public partial class AlleAnzeigenView : UserControl
    {
        private Model model;
        public Thread Runner;

        public AlleAnzeigenView(Model model)
        {
            InitializeComponent();
            this.model = model;
            DataContext = this;
            Title = "AlleAnzeigenView";
            filterAnzeigenView.Model = model;
        }

        private string title;
        public string Title
        {
            get { return title; }
            set
            {
                if (Title != value)
                {
                    title = value;
                    //this.OnPropertyChanged("Title");
                }
            }
        }

        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            Logger.LogEvent(LogEvent.InserateAufgerufen, model.Guid);
            filterAnzeigenView.UnfilteredAnzeigen.Clear();
            Runner = new Thread(new ThreadStart(LoadData));
            Runner.Start();
            //ExecuteFiltering();
        }

        public delegate void ListDelegate(IEnumerable<Anzeige> anzeigen);
        public ListDelegate myDelegate;

        //public void AddItems(IEnumerable<Anzeige> anzeigen)
        //{
        //    foreach (Anzeige anz in anzeigen)
        //        filterAnzeigenView.UnfilteredAnzeigen.Add(anz);
        //}

        public void AddItems(IEnumerable<Anzeige> anzeigen)
        {
            filterAnzeigenView.UnfilteredAnzeigen = new ObservableCollection<Anzeige>(anzeigen);
            filterAnzeigenView.executeFilter();
        }

        //private void LoadData()
        //{
        //    myDelegate = new ListDelegate(AddItems);
        //    try
        //    {
        //        ObservableCollection<Anzeige> tmpAnzeigen = new ObservableCollection<Anzeige>();
        //        Proxy fassade = new Proxy();
        //        List<Anzeige> tmpList2 = fassade.GetAllAnzeigen(model.Guid, 0).ToList();

        //        Anzeige[] safeList;
        //        safeList = new Anzeige[tmpList2.Count];
        //        tmpList2.CopyTo(safeList);
        //        this.Dispatcher.BeginInvoke(DispatcherPriority.Background, myDelegate, safeList);
        //        int counter2 = 1;
        //        while (tmpList2 != null && tmpList2.Count > 0)
        //        {
        //            tmpList2 = fassade.GetAllAnzeigen(model.Guid, counter2++).ToList();
        //            safeList = new Anzeige[tmpList2.Count];
        //            tmpList2.CopyTo(safeList);
        //            this.Dispatcher.BeginInvoke(DispatcherPriority.Background, myDelegate, safeList);
        //        }
        //    }
        //    catch (Exception ex) { }
        //}

        public void LoadData()
        {
            myDelegate = new ListDelegate(AddItems);
            try
            {
                ObservableCollection<Anzeige> tmpAnzeigen = new ObservableCollection<Anzeige>();
                Proxy fassade = new Proxy();
                List<Anzeige> resultList = new List<Anzeige>();
                List<Anzeige> tmpList2 = fassade.GetAllAnzeigen(model.Guid, 0).ToList();
                foreach (var element in tmpList2)
                    resultList.Add(element);
                //Anzeige[] safeList;
                //safeList = new Anzeige[tmpList2.Count];
                //tmpList2.CopyTo(safeList);
                //this.Dispatcher.BeginInvoke(DispatcherPriority.Background, myDelegate, safeList);
                int counter2 = 1;
                while (tmpList2 != null && tmpList2.Count > 0)
                {
                    tmpList2 = fassade.GetAllAnzeigen(model.Guid, counter2++).ToList();
                    foreach (var element in tmpList2)
                        resultList.Add(element);
                    //safeList = new Anzeige[tmpList2.Count];
                    //tmpList2.CopyTo(safeList);
                    //this.Dispatcher.BeginInvoke(DispatcherPriority.Background, myDelegate, safeList);
                }
                this.Dispatcher.BeginInvoke(DispatcherPriority.Background, myDelegate, resultList);
            }
            catch (Exception ex) { }
        }

        private void UserControl_Unloaded(object sender, RoutedEventArgs e)
        {
            if (Runner != null)
                Runner.Interrupt();
        }
    }
}
