﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using BasisKlassen;
using Common.Logger;

namespace AnzeigenApp
{
    /// <summary>
    /// Interaktionslogik für DurchsuchenView.xaml
    /// </summary>
    public partial class DurchsuchenView : MyUserControl
    {
        private Model model;
        public AlleAnzeigenView AlleAnzeigenView;
        public EigeneAnzeigenView EigeneAnzeigenView;
        public ImageBrush buttonBackgroundPressed;
        public SolidColorBrush buttonBackgroundNotPressed;

        public DurchsuchenView(Model model)
        {
            InitializeComponent();
            this.model = model;
            DataContext = this;
            Title = "INSERATE";
            AlleAnzeigenView = new AlleAnzeigenView(model);
            EigeneAnzeigenView = new EigeneAnzeigenView(model);
            var bmp = new BitmapImage();
            bmp.BeginInit();
            //bmp.UriSource = new Uri("C://Users//Marius//Documents//Visual Studio 2010//Projects//Schwarzes Brett//Schwarzes-Brett-v1//Resourcen//selector.png");
            bmp.UriSource = new Uri("C://Resourcen//selector.png");
            bmp.EndInit();
            buttonBackgroundPressed = new ImageBrush(bmp);
            buttonBackgroundNotPressed = new SolidColorBrush(new Color());
            contentControl.Content = AlleAnzeigenView;
            btnAlleAnzeigen.Background = buttonBackgroundPressed;
            //views = new ObservableCollection<Control>();
            //views.Add(AlleAnzeigenView);
        }

        public void SetToOnlineMode(bool online)
        {
            if (online)
            {
                btnEigeneAnzeigen.Visibility = Visibility.Visible;
                //views.Add(EigeneAnzeigenView);
            }
            else
            {
                btnEigeneAnzeigen.Visibility = Visibility.Collapsed;
                btnEigeneAnzeigen.Background = buttonBackgroundNotPressed;
                contentControl.Content = AlleAnzeigenView;
                this.AlleAnzeigenView.filterAnzeigenView.SelectedAnzeige = null;
                btnAlleAnzeigen.Background = buttonBackgroundPressed;
                //views.Remove(EigeneAnzeigenView);
            }
        }

        private void btnAlleAnzeigen_Click(object sender, RoutedEventArgs e)
        {
            contentControl.Content = AlleAnzeigenView;
            btnAlleAnzeigen.Background = buttonBackgroundPressed;
            btnEigeneAnzeigen.Background = buttonBackgroundNotPressed;
            AlleAnzeigenView.filterAnzeigenView.SelectedAnzeige = null;
            AlleAnzeigenView.filterAnzeigenView.FilterString = String.Empty;
        }

        private void btnEigeneAnzeigen_Click(object sender, RoutedEventArgs e)
        {
            contentControl.Content = EigeneAnzeigenView;
            btnEigeneAnzeigen.Background = buttonBackgroundPressed;
            btnAlleAnzeigen.Background = buttonBackgroundNotPressed;
            EigeneAnzeigenView.filterAnzeigenView.SelectedAnzeige = null;
            EigeneAnzeigenView.filterAnzeigenView.FilterString = String.Empty;
        }
    }
}
