﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Service.BoardService;
using System.Collections.ObjectModel;
using System.Threading;
using System.Windows.Threading;
using System.ComponentModel;
using Service;
using Microsoft.Surface.Presentation.Controls;
using Common.Logger;

namespace AnzeigenApp
{
    /// <summary>
    /// Interaktionslogik für FilterAnzeigenView.xaml
    /// </summary>
    public partial class FilterAnzeigenView : UserControl, INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;
        //public ImageBrush buttonBackgroundPressed;
        //public SolidColorBrush buttonBackgroundNotPressed;


        public FilterAnzeigenView()
        {
            InitializeComponent();
            DataContext = this;
            unfilteredAnzeigen = new ObservableCollection<Anzeige>();
            unfilteredAnzeigen.CollectionChanged += OnCollectionChanged;
            filteredAnzeigen = new ObservableCollection<Anzeige>();
            Kategorien = new List<Kategorie>();
            //var bmp = new BitmapImage();
            //bmp.BeginInit();
            ////bmp.UriSource = new Uri("C://Users//Marius//Documents//Visual Studio 2010//Projects//Schwarzes Brett//Schwarzes-Brett-v1//Resourcen//haken.png");
            //bmp.UriSource = new Uri("C://Resourcen//haken.png");
            //bmp.EndInit();
            //buttonBackgroundPressed = new ImageBrush(bmp);
            //buttonBackgroundNotPressed = new SolidColorBrush(new Color());
        }

        private Model model;
        public Model Model
        {
            get
            {
                return model;
            }
            set
            {
                if (model != value)
                {
                    model = value;
                    //Kategorien = model.Kategorien;
                    //this.OnPropertyChanged("Views");
                }
            }
        }

        private UserControl selectedAnzeigeView;
        public UserControl SelectedAnzeigeView
        {
            get
            {
                return selectedAnzeigeView;
            }
            set
            {
                if (selectedAnzeigeView != value)
                {
                    selectedAnzeigeView = value;
                    this.OnPropertyChanged("SelectedAnzeigeView");
                }
            }
        }

        private String filterString;
        public String FilterString
        {
            get
            {
                return filterString;
            }
            set
            {
                if (filterString != value)
                {
                    filterString = value;
                    new Thread(new ThreadStart(executeFilter)).Start();
                    this.OnPropertyChanged("FilterString");
                }
            }
        }

        //private ObservableCollection<Anzeige> alleAnzeigen;

        private ObservableCollection<Anzeige> unfilteredAnzeigen;

        public ObservableCollection<Anzeige> UnfilteredAnzeigen
        {
            get
            {
                return unfilteredAnzeigen;
            }
            set
            {
                if (unfilteredAnzeigen != value)
                {
                    unfilteredAnzeigen = value;
                    //this.OnPropertyChanged("UnfilteredAnzeigen");
                }
            }
        }

        private IList<String> kategorienStufe3;

        public IList<String> KategorienStufe3
        {
            get
            {
                return kategorienStufe3;
            }
            set
            {
                if (kategorienStufe3 != value)
                {
                    kategorienStufe3 = value;
                    this.OnPropertyChanged("KategorienStufe3");
                }
            }
        }


        private IList<Kategorie> kategorienStufe2;

        public IList<Kategorie> KategorienStufe2
        {
            get
            {
                return kategorienStufe2;
            }
            set
            {
                if (kategorienStufe2 != value)
                {
                    kategorienStufe2 = value;
                    this.OnPropertyChanged("KategorienStufe2");
                }
            }
        }

        private IList<Kategorie> kategorien;

        public IList<Kategorie> Kategorien
        {
            get
            {
                return kategorien;
            }
            set
            {
                if (Kategorien != value)
                {
                    kategorien = value;
                    this.OnPropertyChanged("kategorien");
                }
            }
        }

        private ObservableCollection<Anzeige> filteredAnzeigen;

        public ObservableCollection<Anzeige> FilteredAnzeigen
        {
            get
            {
                return filteredAnzeigen;
            }
            set
            {
                if (filteredAnzeigen != value)
                {
                    filteredAnzeigen = value;
                    this.OnPropertyChanged("FilteredAnzeigen");
                }
            }
        }

        private ObservableCollection<Anzeige> resultAnzeigen1;
        public ObservableCollection<Anzeige> ResultAnzeigen1
        {
            get
            {
                return resultAnzeigen1;
            }
            set
            {
                if (resultAnzeigen1 != value)
                {
                    resultAnzeigen1 = value;
                    this.OnPropertyChanged("ResultAnzeigen1");
                }
            }
        }

        private ObservableCollection<Anzeige> resultAnzeigen2;
        public ObservableCollection<Anzeige> ResultAnzeigen2
        {
            get
            {
                return resultAnzeigen2;
            }
            set
            {
                if (resultAnzeigen2 != value)
                {
                    resultAnzeigen2 = value;
                    this.OnPropertyChanged("ResultAnzeigen2");
                }
            }
        }


        private Anzeige selectedAnzeige;

        public Anzeige SelectedAnzeige
        {
            get
            {
                return selectedAnzeige;
            }
            set
            {
                if (SelectedAnzeige != value)
                {
                    selectedAnzeige = value;

                    OnPropertyChanged("SelectedAnzeige");
                    OnPropertyChanged("IsSelectedAnzeige");
                    OnPropertyChanged("IsNotSelectedAnzeige");
                    try
                    {
                        Proxy fassade = new Proxy();
                        if (fassade.IstOwnAnzeige(Model.Guid, selectedAnzeige.ID))
                        {
                            SelectedAnzeigeView = new EigeneAnzeigeDetailView(selectedAnzeige, this);
                        }
                        else
                        {
                            SelectedAnzeigeView = new AnzeigeDetailView(selectedAnzeige, model.Guid, this);
                        }
                    }
                    catch (Exception ex) { }
                }
            }
        }

        public bool IsSelectedAnzeige
        {
            get
            {
                return SelectedAnzeige != null;
            }
        }

        public bool IsNotSelectedAnzeige
        {
            get
            {
                return SelectedAnzeige == null;
            }
        }

        //private void UserControl_Loaded(object sender, RoutedEventArgs e)
        //{
        //    alleAnzeigen = AnzeigenUpdater.Anzeigen;
        //    ExecuteFiltering();
        //}

        //private void ExecuteFiltering()
        //{
        //    FilteredAnzeigen = alleAnzeigen;
        //}

        public void executeFilter()
        {
            IEnumerable<Anzeige> tmpFiltered = unfilteredAnzeigen;
            if (!String.IsNullOrEmpty(filterString))
            {
                string filter = filterString.ToLower();
                tmpFiltered = tmpFiltered.Where(x =>
                    x.Titel.ToLower().Contains(filter) ||
                    x.Beschreibung.ToLower().Contains(filter) ||
                    x.Text.ToLower().Contains(filter) || x.Tags.Any(y => y.ToLower().Contains(filter)));
            }
            if (!String.IsNullOrEmpty(selectedKategorie1))
            {
                try
                {
                    tmpFiltered = tmpFiltered.Where(x => x.Kategorie.Where(y => y.Key == 1).Single().Value.Equals(selectedKategorie1));
                    var tmpKats2 = new List<String>(selectedKategorie2);
                    if (tmpKats2 != null && tmpKats2.Count() > 0)
                    {
                        tmpFiltered = tmpFiltered.Where(x => x.Kategorie.Where(y => y.Key == 2).Count() > 0).Where(x => tmpKats2.Contains(x.Kategorie.Where(y => y.Key == 2).Single().Value));
                        var tmpKats3 = new List<String>(selectedKategorie3);
                        if (tmpKats3 != null && tmpKats3.Count() > 0 )
                        {
                            tmpFiltered = tmpFiltered.Where(x => x.Kategorie.Where(y => y.Key == 3).Count() > 0).Where(x => tmpKats3.Contains(x.Kategorie.Where(y => y.Key == 3).Single().Value));
                        }
                    }
                }
                catch (Exception ex) { }
            }
            this.Dispatcher.Invoke(DispatcherPriority.Background, (Action)(() =>
            {
                int count = 0;
                try
                {
                    count = tmpFiltered.Count();
                }
                catch (Exception ex) { }
                if (count > 1)
                {
                    ResultAnzeigen1 = new ObservableCollection<Anzeige>(tmpFiltered.Take(1 + count / 2));
                    ResultAnzeigen2 = new ObservableCollection<Anzeige>(tmpFiltered.Skip(resultAnzeigen1.Count()));

                    int leftCount = resultAnzeigen1.Count() - ResultAnzeigen2.Count();
                    for (int i = 0; i < leftCount; i++)
                        ResultAnzeigen2.Add(new Anzeige());
                }
                else
                {
                    ResultAnzeigen1 = new ObservableCollection<Anzeige>(tmpFiltered.Take(count));
                    ResultAnzeigen2 = null;
                }
            }));
        }

        protected virtual void OnCollectionChanged(object obj, System.Collections.Specialized.NotifyCollectionChangedEventArgs args)
        {
            executeFilter();
        }

        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        private String selectedKategorie1 = "";
        private IEnumerable<String> selectedKategorie2 = new List<String>();
        private IEnumerable<String> selectedKategorie3 = new List<String>();

        private void kategorieList2_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Logger.LogEvent(LogEvent.KategorieGewählt, model.Guid);
            try
            {
                if (kategorieList2.SelectedItems.Count > 0)
                {
                    List<Kategorie> mergedKategorien = new List<Kategorie>();
                    foreach (Kategorie k in kategorieList2.SelectedItems.Cast<Kategorie>())
                        foreach (Kategorie subK in k.Unterkategorien)
                            mergedKategorien.Add(subK);
                    selectedKategorie2 = convert(kategorieList2.SelectedItems.Cast<Kategorie>());
                    KategorienStufe3 = convert(mergedKategorien).ToList();
                    new Thread(new ThreadStart(executeFilter)).Start();
                }
                else
                {
                    selectedKategorie2 = null;
                    KategorienStufe3 = new List<String>();
                    new Thread(new ThreadStart(executeFilter)).Start();
                }
            }
            catch (Exception ex) { }
        }

        private void kategorieList3_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Logger.LogEvent(LogEvent.KategorieGewählt, model.Guid);
            try
            {
                if (kategorieList3.SelectedItems.Count > 0)
                {
                    selectedKategorie3 = kategorieList3.SelectedItems.Cast<String>();
                    new Thread(new ThreadStart(executeFilter)).Start();
                }
                else
                {
                    selectedKategorie3 = null;
                    new Thread(new ThreadStart(executeFilter)).Start();
                }
            }
            catch (Exception ex) { }
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            SelectedAnzeige = null;
        }

        public IEnumerable<String> convert(IEnumerable<Kategorie> enumerable)
        {
            foreach (Kategorie o in enumerable)
                yield return o.Name;
        }

        private void UserControl_Loaded_1(object sender, RoutedEventArgs e)
        {
            try
            {
                Proxy fassade = new Proxy();
                IList<Kategorie> allKategorien = fassade.GetAllKategorien();
                IList<Kategorie> kategorien = new List<Kategorie>();
                foreach (Kategorie k in allKategorien.Take(allKategorien.Count))
                    kategorien.Add(k);
                foreach (Kategorie k in allKategorien)
                {
                    if(k.Unterkategorien!=null)
                        foreach (Kategorie kat in k.Unterkategorien)
                        {
                            kategorien.Remove(kategorien.Where(x => x.Name.Equals(kat.Name)).SingleOrDefault());
                        }
                }
                Kategorien = kategorien;
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
                //MessageBox.Show("Kategorien konnten nicht abgerufen werden");
            }
            try
            {
                btnKat1.Content = Kategorien.Where(x => x.Name.ToLower().Equals("angebot")).First().Name;
                btnKat2.Content = Kategorien.Where(x => x.Name.ToLower().Equals("gesuch")).First().Name;
            }
            catch (Exception ex)
            {
                //MessageBox.Show("Es sind keine 2 Oberkategorien verfügbar");
            }
        }

        private void btnKat1_Click(object sender, RoutedEventArgs e)
        {
            setKategorie1(sender);
            imgKat1Pressed.Visibility = Visibility.Visible;
            imgKat2Pressed.Visibility = Visibility.Hidden;
            //btnKat1.Background = buttonBackgroundPressed;
            //btnKat2.Background = buttonBackgroundNotPressed;
        }

        private void btnKat2_Click(object sender, RoutedEventArgs e)
        {
            setKategorie1(sender);
            imgKat2Pressed.Visibility = Visibility.Visible;
            imgKat1Pressed.Visibility = Visibility.Hidden;
            //btnKat1.Background = buttonBackgroundNotPressed;
            //btnKat2.Background = buttonBackgroundPressed;
        }

        public void setKategorie1(object sender)
        {
            Logger.LogEvent(LogEvent.KategorieGewählt, model.Guid);
            try
            {
                var btn = sender as SurfaceButton;
                if (btn != null)
                {
                    selectedKategorie1 = btn.Content as String;
                    KategorienStufe2 = Kategorien.Where(x => x.Name.Equals(selectedKategorie1)).Single().Unterkategorien;
                    new Thread(new ThreadStart(executeFilter)).Start();
                }
                else
                {
                    selectedKategorie1 = null;
                    KategorienStufe2 = null;
                    new Thread(new ThreadStart(executeFilter)).Start();
                }
            }
            catch (Exception ex) { }
        }

        public SurfaceScrollViewer Scroller
        {
            get { return listBoxFilteredAnzeigen.Template.FindName("Scroller", listBoxFilteredAnzeigen) as SurfaceScrollViewer; }
        }

        private void listBoxFilteredAnzeigen2_ScrollChanged_1(object sender, ScrollChangedEventArgs e)
        {
            var scroller = listBoxFilteredAnzeigen.Template.FindName("Scroller", listBoxFilteredAnzeigen) as SurfaceScrollViewer;
            if (scroller != null)
                scroller.ScrollToHorizontalOffset(e.HorizontalOffset);

        }

        private void listBoxFilteredAnzeigen_ScrollChanged_1(object sender, ScrollChangedEventArgs e)
        {
            var scroller = listBoxFilteredAnzeigen2.Template.FindName("Scroller2", listBoxFilteredAnzeigen2) as SurfaceScrollViewer;
            if (scroller != null)
                scroller.ScrollToHorizontalOffset(e.HorizontalOffset);
        }

        private void SurfaceTextBox_TextChanged_1(object sender, TextChangedEventArgs e)
        {
            Logger.LogEvent(LogEvent.SuchwortGeändert, model.Guid);
            var textBox = sender as SurfaceTextBox;
            //if (textBox.Text.Length > 0)
            //    textBox.Background = new SolidColorBrush(Colors.White);
            //else
            //    textBox.Background = null;
        }

        private void SurfaceButton_Click_1(object sender, RoutedEventArgs e)
        {
            FilterString = String.Empty;
        }

        private void SurfaceButton_Click(object sender, RoutedEventArgs e)
        {
            setKategorie1(null);
            imgKat1Pressed.Visibility = Visibility.Hidden;
            imgKat2Pressed.Visibility = Visibility.Hidden;
        }
    }
}
