﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Collections.ObjectModel;
using System.Windows.Controls;
using Microsoft.Surface.Presentation.Controls;
using Service;
using Service.BoardService;
using BasisKlassen;

namespace AnzeigenApp
{
    public class Model : BaseModel
    {
        private DurchsuchenView durchsuchenView;

        public Model(SurfaceWindow parent)
        {
            parent.Closing += SurfaceWindow_Closing;
            Views = new ObservableCollection<Control>();
            durchsuchenView = new DurchsuchenView(this);
            views.Add(durchsuchenView);

        }

        private ObservableCollection<Control> views;

        public ObservableCollection<Control> Views
        {
            get
            {
                return views;
            }
            set
            {
                if (Views != value)
                {
                    views = value;
                }
            }
        }

        

        public String Guid
        {
            get { return guid; }
            set
            {
                if (guid != value)
                {
                    guid = value;
                    durchsuchenView.SetToOnlineMode(!String.IsNullOrEmpty(guid));
                }
            }
        }

        private void SurfaceWindow_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            try
            {
                durchsuchenView.AlleAnzeigenView.Runner.Interrupt();
            }
            catch (Exception ex) { }
            try
            {
                durchsuchenView.EigeneAnzeigenView.Runner.Interrupt();
            }
            catch (Exception ex) { }
        }
    }
}
