﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using FluentNHibernate.Mapping;
using System.Runtime.Serialization;

namespace AnzeigenKomponente
{
    [DataContract(Namespace = "http://marius-klausa.eu/board")]
    public class Kategorie : IEquatable<Kategorie>
    {
        [DataMember]
        public virtual int ID { get; private set; }
        [DataMember]
        public virtual String Name { get; private set; }
        [DataMember]
        public virtual IList<Kategorie> Unterkategorien { get; private set; }
        //[DataMember]
        //public virtual Kategorie Oberkategorie { get; private set; }

        public Kategorie() { }

        public Kategorie(String name)
            : this(name, null)
        {
        }

        public Kategorie(String name, IList<Kategorie> unterkategorien)
        {
            this.Name = name;
            this.Unterkategorien = unterkategorien;
        }

        override public String ToString()
        {
            return String.Format("{0}-{1}", Name, ID);
        }

        //public Kategorie(String name, Kategorie oberkategorie)
        //{
        //    this.Name = name;
        //    this.Oberkategorie = oberkategorie;
        //}

        public override bool Equals(object obj)
        {
            var kat = obj as Kategorie;
            return kat != null && kat.Name.Equals(Name);
        }

        public override int GetHashCode()
        {
            return Name.GetHashCode();
        }

        public virtual bool Equals(Kategorie other)
        {
            return other != null && other.Name.Equals(Name);
        }
    }

    public class KategorieMap : ClassMap<Kategorie>
    {
        public KategorieMap()
        {
            Id(x => x.ID);
            Map(x => x.Name).Unique();
            //References<Kategorie>(x => x.Oberkategorie).LazyLoad(Laziness.False).Cascade.None();
            HasManyToMany(x => x.Unterkategorien).Table("UnterkategorienZuweisung").ParentKeyColumn("Oberkategorie").ChildKeyColumn("Unterkategorie").Not.LazyLoad().Cascade.None();
        }
    }
}
