﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Windows.Controls;
using Microsoft.Surface.Presentation.Controls;

namespace BasisKlassen
{
    public class MyPasswordBox : SurfaceTextBox
    {
        private static object lockObject = new object();
        private bool isAutoChanged = false;

        public MyPasswordBox()
        {
            this.TextChanged += new TextChangedEventHandler(myTextChanged);
        }

        public String Password = "";
        private void myTextChanged(object sender, TextChangedEventArgs e)
        {
            if (isAutoChanged)
                return;
            int added = e.Changes.First().AddedLength;
            int removed = e.Changes.First().RemovedLength;
            if (removed > 0)
            {
                Password = Password.Substring(0, Password.Length - removed);
            }
            if (added > 0)
            {
                Password += Text.Substring(Text.Length - added);
                isAutoChanged = true;
                Text = "";
                for (int i = 0; i < Password.Length; i++)
                    Text += "*";
                isAutoChanged = false;
            }
            CaretIndex = Text.Length;
        }
    }
}
