﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PersistenzManager;

namespace BilderKomponente
{
    public class BilderVerwalter
    {
        private IPersistenz persistenz = null;

        public BilderVerwalter(IPersistenz persistenz)
        {
            this.persistenz = persistenz;
        }

        public void SaveImageIfNotExist(Image image)
        {
            if (!persistenz.LinqQuery<Image>().Any(x => x.Hash.Equals(image.Hash)))
                persistenz.Save<Image>(image);
        }

        public void SaveImage(Image image)
        {
            persistenz.Save<Image>(image);
        }

        public Image GetImage(int imageID)
        {
            return (from a in persistenz.LinqQuery<Image>()
                    where a.ID.Equals(imageID)
                    select a).SingleOrDefault<Image>();
        }

        public Image GetImage(string hash)
        {
            return (from a in persistenz.LinqQuery<Image>()
                    where a.Hash.Equals(hash)
                    select a).SingleOrDefault<Image>();
        }
    }
}
