﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using Service;
using Service.BoardService;

namespace CampusBoardWebsite
{
    public partial class ErstellenFinal : AuthorizedContentWebPage
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            CheckSessionAndRedirect(true);

        }

        private void saveImages()
        {
            var idss = new List<int>();
            Session.Add("images", idss);
            var fassade = new Proxy();
            foreach (var file in files.PostedFiles)
            {
                try
                {
                    string fileName = System.IO.Path.GetFileName(file.FileName);

                    string fileExtension = System.IO.Path.GetExtension(fileName).ToLower();

                    if (fileExtension.Equals(".jpg") || fileExtension.Equals(".png") || fileExtension.Equals(".bmp"))
                    {
                        Stream stream = file.InputStream;
                        FileTransferRequest request = new FileTransferRequest(Guid, stream);
                        FileTransferResult result = fassade.ImageErstellen(request);
                        if (result.imageID != -1)
                        {
                            List<int> ids = (List<int>)Session["images"];
                            if (!ids.Contains(result.imageID))
                                ids.Add(result.imageID);

                        }
                    }
                }
                catch (Exception ex)
                {
                    alertError.Visible = true;
                    alertSuccess.Visible = false;
                    lblError.Text = "Erstellen der Anzeige fehlgeschlagen!";
                }

            }
        }

        protected void btnErstellen_Click(object sender, EventArgs e)
        {
                saveImages();
                var fassade = new Proxy();
                List<int> ids = (List<int>)Session["images"];
                if (ids == null)
                    ids = new List<int>();
                //Session.Add("final_titel", titel);
                //Session.Add("final_text", text);
                //Session.Add("final_tags", tags.ToArray());
                //Session.Add("final_kategory", realKats);
                //Session.Add("final_images", ids.ToArray());
                //Session.Add("final_opt", opt);
                var titel = Session["final_titel"]as String;
                var text = Session["final_text"] as String;
                var tags = Session["final_tags"] as Tag[];
                var realKats = Session["final_kategory"] as Dictionary<int,int>;
                //var ids = Session["final_images"]as int[];
                var opt = (KontaktOptionen)Enum.Parse(typeof(KontaktOptionen), (Session["final_opt"] as String));
                Anzeige tmp = fassade.AnzeigeErstellen(Guid, titel, "", text, tags,
                                     realKats, "default", ids.ToArray(), opt);
                divPics.Visible = false;
                if (tmp == null)
                {
                    alertError.Visible = true;
                    alertSuccess.Visible = false;
                    lblError.Text = "Erstellen der Anzeige fehlgeschlagen!";
                }
                else
                {
                    alertError.Visible = false;
                    alertSuccess.Visible = true;
                    lblSuccess.Text = "Ihre Anzeige wurde erfolgreich erstellt. Sie ist nun auf dem Campus-Board sichtbar!!";
                }
                ids.Clear();
        }
    }
}