﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using PersistenzManager;
using Common;

namespace FeedbackKomponente
{
    public class FeedbackKomponente
    {
        private IPersistenz persistenz;

        public FeedbackKomponente(IPersistenz persistenz)
        {
            this.persistenz = persistenz;
        }

        public bool PostFeedback(String text)
        {
            Feedback data = new Feedback() { Text = text, Date = DateTime.Now };
            persistenz.Save<Feedback>(data);
            MailKomponente.MailKomponente.SendMail(AppConfHelper.GetValueAsString("FeedbackReceiver"), "Feedback gepostet", text);
            if (data.ID > 0)
                return true;
            return false;
        }

        public IList<Feedback> GetFeedbackList(int chunk)
        {
            return persistenz.LinqQuery<Feedback>().Skip(10 * chunk).Take(10).ToList();
        }
    }
}
