﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using FluentNHibernate.Mapping;


namespace AccountVerwaltungsKomponente
{
    public class Aktivierung
    {
        public virtual int ID { get; set; }
        public virtual string Aktivierungscode { get; set; }
        public virtual string MailAdress { get; set; }
        public virtual int AccountID { get; private set; }

        public Aktivierung() { }

        public Aktivierung(string aktivierungscode, string mailAdress, int accountID)
        {
            this.Aktivierungscode = aktivierungscode;
            this.MailAdress = mailAdress;
            this.AccountID = accountID;
        }
    }

    public class AktivierungMap : ClassMap<Aktivierung>
    {
        public AktivierungMap()
        {
            Id(x => x.ID);
            Map(x => x.AccountID).Unique();
            Map(x => x.Aktivierungscode);
            Map(x => x.MailAdress).Unique();
        }
    }
}
