﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using Common;
using MailKomponente;

namespace StatusKomponente
{
    public class StatusKomponente
    {
        private DateTime lastHeartbeat;
        private TimeSpan heartbeatIntervall;
        private bool isAlive = true;
        private Timer timer;

        public void Start()
        {
            heartbeatIntervall = new TimeSpan(0, 0, AppConfHelper.GetValueAsInt("heartbeat_time"));
            //isRunning = true;
            ////new Task(() => Run()).Start();
            lastHeartbeat = DateTime.Now;
            timer = new Timer(new TimerCallback(Run), null, 0, 5000);
        }

        public void Stop()
        {
            timer = null;
        }

        public void IsAlive()
        {

            if (!isAlive)
                MailKomponente.MailKomponente.SendMail(AppConfHelper.GetValueAsString("FeedbackReceiver"), "Campus-Board Wieder online", "Das Campus-Board sendet wieder heartbeats!");
            isAlive = true;
            lastHeartbeat = DateTime.Now;
        }

        private void Run(object info)
        {
            if (lastHeartbeat + heartbeatIntervall < DateTime.Now)
            {
                if (isAlive)
                    MailKomponente.MailKomponente.SendMail(AppConfHelper.GetValueAsString("FeedbackReceiver"), "Campus-Board Ausfall", "Das Campus-Board hat aufgehört heartbeats zu senden. Sofort prüfen!!");
                isAlive = false;
            }
        }

        public bool Status()
        {
            return isAlive;
        }
    }
}
